<?php

/**
 * Theme Options
 *
 * @package construction_engineer
*/

// ---------------------------------------- GENERAL OPTIONBS ----------------------------------------------------


// ---------------------------------------- PRELOADER ----------------------------------------------------


// General Options
$wp_customize->add_section(
	'construction_engineer_general_options',
	array(
		'panel' => 'construction_engineer_theme_options',
		'title' => esc_html__( 'General Options', 'construction-engineer' ),
	)
);

// Add Separator Custom Control
$wp_customize->add_setting( 'construction_engineer_preloader_separator', array(
	'sanitize_callback' => 'sanitize_text_field',
) );

$wp_customize->add_control( new Construction_Engineer_Separator_Custom_Control( $wp_customize, 'construction_engineer_preloader_separator', array(
	'label' => __( 'Enable / Disable Site Preloader Section', 'construction-engineer' ),
	'section' => 'construction_engineer_general_options',
	'settings' => 'construction_engineer_preloader_separator',
) ) );

// General Options - Enable Preloader.
$wp_customize->add_setting(
	'construction_engineer_enable_preloader',
	array(
		'sanitize_callback' => 'construction_engineer_sanitize_switch',
		'default'           => false,
	)
);

$wp_customize->add_control(
	new Construction_Engineer_Toggle_Switch_Custom_Control(
		$wp_customize,
		'construction_engineer_enable_preloader',
		array(
			'label'   => esc_html__( 'Enable Preloader', 'construction-engineer' ),
			'section' => 'construction_engineer_general_options',
		)
	)
);

// Preloader Style Setting
$wp_customize->add_setting(
    'construction_engineer_preloader_style',
    array(
        'default'           => 'style1',
        'sanitize_callback' => 'sanitize_text_field',
    )
);

$wp_customize->add_control(
    'construction_engineer_preloader_style',
    array(
        'type'     => 'select',
        'label'    => esc_html__('Select Preloader Styles', 'construction-engineer'),
		'active_callback' => 'construction_engineer_is_preloader_style',
        'section'  => 'construction_engineer_general_options',
        'choices'  => array(
            'style1' => esc_html__('Style 1', 'construction-engineer'),
            'style2' => esc_html__('Style 2', 'construction-engineer'),
            'style3' => esc_html__('Style 3', 'construction-engineer'),
        ),
    )
);


// Preloader Background Color Setting
$wp_customize->add_setting(
	'construction_engineer_preloader_background_color_setting',
	 array(
		'default' => '',
		'sanitize_callback' => 'sanitize_hex_color',
	)
);

$wp_customize->add_control(
	new WP_Customize_Color_Control(
		$wp_customize, 'construction_engineer_preloader_background_color_setting', 
		array(
			'label' => __('Preloader Background Color', 'construction-engineer'),
			'active_callback' => 'construction_engineer_is_preloader_style',
			'section' => 'construction_engineer_general_options',
		)
	)
);

// Preloader Background Image Setting
$wp_customize->add_setting(
	'construction_engineer_preloader_background_image_setting', 
	array(
		'default' => '',
		'sanitize_callback' => 'esc_url_raw',
	)
);

$wp_customize->add_control(
	new WP_Customize_Image_Control(
		$wp_customize, 'construction_engineer_preloader_background_image_setting',
		 array(
			'label' => __('Preloader Background Image', 'construction-engineer'),
			'active_callback' => 'construction_engineer_is_preloader_style',
			'section' => 'construction_engineer_general_options',
		)
	)
);

// ---------------------------------------- PAGINATION ----------------------------------------------------


// Add Separator Custom Control
$wp_customize->add_setting( 'construction_engineer_pagination_separator', array(
	'sanitize_callback' => 'sanitize_text_field',
) );

$wp_customize->add_control( new Construction_Engineer_Separator_Custom_Control( $wp_customize, 'construction_engineer_pagination_separator', array(
	'label' => __( 'Enable / Disable Pagination Section', 'construction-engineer' ),
	'section' => 'construction_engineer_general_options',
	'settings' => 'construction_engineer_pagination_separator',
) ) );

// Pagination - Enable Pagination.
$wp_customize->add_setting(
	'construction_engineer_enable_pagination',
	array(
		'default'           => true,
		'sanitize_callback' => 'construction_engineer_sanitize_switch',
	)
);

$wp_customize->add_control(
	new Construction_Engineer_Toggle_Switch_Custom_Control(
		$wp_customize,
		'construction_engineer_enable_pagination',
		array(
			'label'    => esc_html__( 'Enable Pagination', 'construction-engineer' ),
			'section'  => 'construction_engineer_general_options',
			'settings' => 'construction_engineer_enable_pagination',
			'type'     => 'checkbox',
		)
	)
);

// Pagination - Pagination Type.
$wp_customize->add_setting(
	'construction_engineer_pagination_type',
	array(
		'default'           => 'default',
		'sanitize_callback' => 'construction_engineer_sanitize_select',
	)
);

$wp_customize->add_control(
	'construction_engineer_pagination_type',
	array(
		'label'           => esc_html__( 'Pagination Type', 'construction-engineer' ),
		'section'         => 'construction_engineer_general_options',
		'settings'        => 'construction_engineer_pagination_type',
		'active_callback' => 'construction_engineer_is_pagination_enabled',
		'type'            => 'select',
		'choices'         => array(
			'default' => __( 'Default (Older/Newer)', 'construction-engineer' ),
			'numeric' => __( 'Numeric', 'construction-engineer' ),
		),
	)
);


// ---------------------------------------- BREADCRUMB ----------------------------------------------------


// Add Separator Custom Control
$wp_customize->add_setting( 'construction_engineer_breadcrumb_separators', array(
	'sanitize_callback' => 'sanitize_text_field',
) );

$wp_customize->add_control( new Construction_Engineer_Separator_Custom_Control( $wp_customize, 'construction_engineer_breadcrumb_separators', array(
	'label' => __( 'Enable / Disable Breadcrumb Section', 'construction-engineer' ),
	'section' => 'construction_engineer_general_options',
	'settings' => 'construction_engineer_breadcrumb_separators',
)));

// Breadcrumb - Enable Breadcrumb.
$wp_customize->add_setting(
	'construction_engineer_enable_breadcrumb',
	array(
		'sanitize_callback' => 'construction_engineer_sanitize_switch',
		'default'           => true,
	)
);

$wp_customize->add_control(
	new Construction_Engineer_Toggle_Switch_Custom_Control(
		$wp_customize,
		'construction_engineer_enable_breadcrumb',
		array(
			'label'   => esc_html__( 'Enable Breadcrumb', 'construction-engineer' ),
			'section' => 'construction_engineer_general_options',
		)
	)
);

// Breadcrumb - Separator.
$wp_customize->add_setting(
	'construction_engineer_breadcrumb_separator',
	array(
		'sanitize_callback' => 'sanitize_text_field',
		'default'           => '/',
	)
);

$wp_customize->add_control(
	'construction_engineer_breadcrumb_separator',
	array(
		'label'           => esc_html__( 'Separator', 'construction-engineer' ),
		'active_callback' => 'construction_engineer_is_breadcrumb_enabled',
		'section'         => 'construction_engineer_general_options',
	)
);


// ---------------------------------------- Website layout ----------------------------------------------------


// Add Separator Custom Control
$wp_customize->add_setting( 'construction_engineer_layuout_separator', array(
	'sanitize_callback' => 'sanitize_text_field',
) );

$wp_customize->add_control( new Construction_Engineer_Separator_Custom_Control( $wp_customize, 'construction_engineer_layuout_separator', array(
	'label' => __( 'Website Layout Setting', 'construction-engineer' ),
	'section' => 'construction_engineer_general_options',
	'settings' => 'construction_engineer_layuout_separator',
)));


$wp_customize->add_setting(
	'construction_engineer_website_layout',
	array(
		'sanitize_callback' => 'construction_engineer_sanitize_switch',
		'default'           => false,
	)
);

$wp_customize->add_control(
	new Construction_Engineer_Toggle_Switch_Custom_Control(
		$wp_customize,
		'construction_engineer_website_layout',
		array(
			'label'   => esc_html__('Boxed Layout', 'construction-engineer'),
			'section' => 'construction_engineer_general_options',
		)
	)
);

$wp_customize->add_setting('construction_engineer_layout_width_margin', array(
	'default'           => 50,
	'sanitize_callback' => 'construction_engineer_sanitize_range_value',
));

$wp_customize->add_control(new Construction_Engineer_Customize_Range_Control($wp_customize, 'construction_engineer_layout_width_margin', array(
		'label'       => __('Set Width', 'construction-engineer'),
		'description' => __('Adjust the width around the website layout by moving the slider. Use this setting to customize the appearance of your site to fit your design preferences.', 'construction-engineer'),
		'section'     => 'construction_engineer_general_options',
		'settings'    => 'construction_engineer_layout_width_margin',
		'active_callback' => 'construction_engineer_is_layout_enabled',
		'input_attrs' => array(
			'min'  => 0,
			'max'  => 130,
			'step' => 1,
		),
)));



// ---------------------------------------- HEADER OPTIONS ----------------------------------------------------


// Header Options
$wp_customize->add_section(
	'construction_engineer_header_options',
	array(
		'panel' => 'construction_engineer_theme_options',
		'title' => esc_html__( 'Header Options', 'construction-engineer' ),
	)
);

// Add setting for sticky header
$wp_customize->add_setting(
	'construction_engineer_enable_sticky_header',
	array(
		'sanitize_callback' => 'construction_engineer_sanitize_switch',
		'default'           => false,
	)
);

// Add control for sticky header setting
$wp_customize->add_control(
	new Construction_Engineer_Toggle_Switch_Custom_Control(
		$wp_customize,
		'construction_engineer_enable_sticky_header',
		array(
			'label'   => esc_html__( 'Enable Sticky Header', 'construction-engineer' ),
			'section' => 'construction_engineer_header_options',
		)
	)
);

// Banner Section - Enable Section.
$wp_customize->add_setting(
	'construction_engineer_enable_header_search_section',
	array(
		'default'           => true,
		'sanitize_callback' => 'construction_engineer_sanitize_switch',
	)
);

$wp_customize->add_control(
	new Construction_Engineer_Toggle_Switch_Custom_Control(
		$wp_customize,
		'construction_engineer_enable_header_search_section',
		array(
			'label'    => esc_html__( 'Enable Search Section', 'construction-engineer' ),
			'section'  => 'construction_engineer_header_options',
			'settings' => 'construction_engineer_enable_header_search_section',
		)
	)
);

// Banner Section - Button Label.
$wp_customize->add_setting(
	'construction_engineer_header_button_label_',
	array(
		'default'           => '',
		'sanitize_callback' => 'sanitize_text_field',
	)
);

$wp_customize->add_control(
	'construction_engineer_header_button_label_',
	array(
		'label'           => esc_html__( 'Button Label', 'construction-engineer'  ),
		'section'         => 'construction_engineer_header_options',
		'settings'        => 'construction_engineer_header_button_label_',
		'type'            => 'text',
	)
);

// Banner Section - Button Link.
$wp_customize->add_setting(
	'construction_engineer_banner_button_link_',
	array(
		'default'           => '',
		'sanitize_callback' => 'esc_url_raw',
	)
);

$wp_customize->add_control(
	'construction_engineer_banner_button_link_',
	array(
		'label'           => esc_html__( 'Button Link', 'construction-engineer' ),
		'section'         => 'construction_engineer_header_options',
		'settings'        => 'construction_engineer_banner_button_link_',
		'type'            => 'url',
	)
);

// Add Separator Custom Control
$wp_customize->add_setting( 'construction_engineer_menu_separator', array(
	'sanitize_callback' => 'sanitize_text_field',
) );

$wp_customize->add_control( new Construction_Engineer_Separator_Custom_Control( $wp_customize, 'construction_engineer_menu_separator', array(
	'label' => __( 'Menu Settings', 'construction-engineer' ),
	'section' => 'construction_engineer_header_options',
	'settings' => 'construction_engineer_menu_separator',
)));

$wp_customize->add_setting( 'construction_engineer_menu_font_size', array(
    'default'           => 16,
    'sanitize_callback' => 'absint',
) );

// Add control for site title size
$wp_customize->add_control( 'construction_engineer_menu_font_size', array(
    'type'        => 'number',
    'section'     => 'construction_engineer_header_options',
    'label'       => __( 'Menu Font Size ', 'construction-engineer' ),
    'input_attrs' => array(
        'min'  => 10,
        'max'  => 100,
        'step' => 1,
    ),
));

// Add setting for menu font weight
$wp_customize->add_setting('construction_engineer_menu_font_weight', array(
    'default'           => '500',
    'sanitize_callback' => 'sanitize_text_field',
));

// Add control for menu font weight
$wp_customize->add_control('construction_engineer_menu_font_weight', array(
    'type'     => 'select',
    'section'  => 'construction_engineer_header_options', 
    'label'    => __('Menu Font Weight', 'construction-engineer'),
    'choices'  => array(
		'100' => __('100','construction-engineer'),
		'200' => __('200','construction-engineer'),
		'300' => __('300','construction-engineer'),
		'400' => __('400','construction-engineer'),
		'500' => __('500','construction-engineer'),
		'600' => __('600','construction-engineer'),
		'700' => __('700','construction-engineer'),
		'800' => __('800','construction-engineer'),
		'900' => __('900','construction-engineer'),
    ),
));

$wp_customize->add_setting( 'menu_text_transform', array(
    'default'           => 'capitalize', // Default value for text transform
    'sanitize_callback' => 'sanitize_text_field',
) );

// Add control for menu text transform
$wp_customize->add_control( 'menu_text_transform', array(
    'type'     => 'select',
    'section'  => 'construction_engineer_header_options',
    'label'    => __( 'Menu Text Transform', 'construction-engineer' ),
    'choices'  => array(
        'none'       => __( 'None', 'construction-engineer' ),
        'capitalize' => __( 'Capitalize', 'construction-engineer' ),
        'uppercase'  => __( 'Uppercase', 'construction-engineer' ),
        'lowercase'  => __( 'Lowercase', 'construction-engineer' ),
    ),
) );


// Menu Text Color 
$wp_customize->add_setting(
	'construction_engineer_menu_text_color', 
	array(
		'default' => '',
		'sanitize_callback' => 'sanitize_hex_color',
	)
);

$wp_customize->add_control(
	new WP_Customize_Color_Control(
		$wp_customize, 
		'construction_engineer_menu_text_color', 
		array(
			'label' => __('Menu Color', 'construction-engineer'),
			'section' => 'construction_engineer_header_options',
		)
	)
);

// Sub Menu Text Color 
$wp_customize->add_setting(
	'construction_engineer_sub_menu_text_color', 
	array(
		'default' => '',
		'sanitize_callback' => 'sanitize_hex_color',
	)
);

$wp_customize->add_control(
	new WP_Customize_Color_Control(
		$wp_customize, 
		'construction_engineer_sub_menu_text_color', 
		array(
			'label' => __('Sub Menu Color', 'construction-engineer'),
			'section' => 'construction_engineer_header_options',
		)
	)
);

$wp_customize->add_setting( 
	'construction_engineer_header_settings_upgraded_features',
	array(
		'sanitize_callback' => 'sanitize_text_field'
	)
);

$wp_customize->add_control(
	'construction_engineer_header_settings_upgraded_features', 
	array(
		'type'=> 'hidden',
		'description' => "
			<div class='customizer-upgraded-features'>
				<i class='fas fa-info-circle'></i>
				<span class='pro-text'>
					Unlock Premium <strong>Features</strong> ?<br>
					<a target='_blank' href='". esc_url(CONSTRUCTION_ENGINEER_PREMIUM_PAGE) ." '>Upgrade Pro</a>
				</div>
			</div>
		",
		'section' => 'construction_engineer_header_options'
	)
);

// ----------------------------------------SITE IDENTITY----------------------------------------------------


// Site Logo - Enable Setting.
$wp_customize->add_setting(
	'construction_engineer_enable_site_logo',
	array(
		'default'           => true, // Default is to display the logo.
		'sanitize_callback' => 'construction_engineer_sanitize_switch', // Sanitize using a custom switch function.
	)
);

$wp_customize->add_control(
	new Construction_Engineer_Toggle_Switch_Custom_Control(
		$wp_customize,
		'construction_engineer_enable_site_logo',
		array(
			'label'    => esc_html__( 'Enable Site Logo', 'construction-engineer' ),
			'section'  => 'title_tagline', // Section to add this control.
			'settings' => 'construction_engineer_enable_site_logo',
		)
	)
);

// Site Title - Enable Setting.
$wp_customize->add_setting(
	'construction_engineer_enable_site_title_setting',
	array(
		'default'           => false,
		'sanitize_callback' => 'construction_engineer_sanitize_switch',
	)
);

$wp_customize->add_control(
	new Construction_Engineer_Toggle_Switch_Custom_Control(
		$wp_customize,
		'construction_engineer_enable_site_title_setting',
		array(
			'label'    => esc_html__( 'Enable Site Title', 'construction-engineer' ),
			'section'  => 'title_tagline',
			'settings' => 'construction_engineer_enable_site_title_setting',
		)
	)
);

// Tagline - Enable Setting.
$wp_customize->add_setting(
	'construction_engineer_enable_tagline_setting',
	array(
		'default'           => false,
		'sanitize_callback' => 'construction_engineer_sanitize_switch',
	)
);
$wp_customize->add_control(
	new Construction_Engineer_Toggle_Switch_Custom_Control(
		$wp_customize,
		'construction_engineer_enable_tagline_setting',
		array(
			'label'    => esc_html__( 'Enable Tagline', 'construction-engineer' ),
			'section'  => 'title_tagline',
			'settings' => 'construction_engineer_enable_tagline_setting',
		)
	)
);

$wp_customize->add_setting( 'construction_engineer_site_title_size', array(
    'default'           => 30, // Default font size in pixels
    'sanitize_callback' => 'absint', // Sanitize the input as a positive integer
) );
// Add control for site title size
$wp_customize->add_control( 'construction_engineer_site_title_size', array(
    'type'        => 'number',
    'section'     => 'title_tagline', // You can change this section to your preferred section
    'label'       => __( 'Site Title Font Size ', 'construction-engineer' ),
    'input_attrs' => array(
        'min'  => 10,
        'max'  => 100,
        'step' => 1,
    ),
) );

$wp_customize->add_setting('construction_engineer_site_logo_width', array(
    'default'           => 200,
    'sanitize_callback' => 'construction_engineer_sanitize_range_value',
));

$wp_customize->add_control(new Construction_Engineer_Customize_Range_Control($wp_customize, 'construction_engineer_site_logo_width', array(
    'label'       => __('Adjust Site Logo Width', 'construction-engineer'),
    'description' => __('This setting controls the Width of Site Logo', 'construction-engineer'),
    'section'     => 'title_tagline',
    'settings'    => 'construction_engineer_site_logo_width',
    'input_attrs' => array(
        'min'  => 0,
        'max'  => 400,
        'step' => 5,
    ),
)));

// ---------------------------------------- ANIMATION ----------------------------------------------------

$wp_customize->add_setting( 'construction_engineer_animation_separator', array(
	'sanitize_callback' => 'sanitize_text_field',
) );
$wp_customize->add_control( new Construction_Engineer_Separator_Custom_Control( $wp_customize, 'construction_engineer_animation_separator', array(
	'label' => __( 'Enable / Disable Animation', 'construction-engineer' ),
	'section' => 'construction_engineer_general_options',
	'settings' => 'construction_engineer_animation_separator',
) ) );
// Animation Enable / Disable
$wp_customize->add_setting('construction_engineer_enable_animation',array(
		'default'           => true,
		'sanitize_callback' => 'construction_engineer_sanitize_switch',
	)
);
$wp_customize->add_control(
	new Construction_Engineer_Toggle_Switch_Custom_Control($wp_customize,'construction_engineer_enable_animation',array(
			'label'   => esc_html__( 'Enable Animation', 'construction-engineer' ),
			'section' => 'construction_engineer_general_options',
		)
	)
);